/*
 * 쐬: 2003/12/08
 *
 */
package com.muimi.zipview;

import java.io.File;
import java.io.IOException;
import java.util.List;
import java.util.zip.ZipEntry;
import java.util.zip.ZipException;
import java.util.zip.ZipFile;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.resources.IResourceChangeEvent;
import org.eclipse.core.resources.IResourceChangeListener;
import org.eclipse.core.resources.IResourceDelta;
import org.eclipse.core.resources.IResourceDeltaVisitor;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IPath;
import org.eclipse.jdt.internal.core.JarEntryFile;
import org.eclipse.jdt.internal.ui.javaeditor.JarEntryEditorInput;
import org.eclipse.jface.viewers.DoubleClickEvent;
import org.eclipse.jface.viewers.IDoubleClickListener;
import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerSorter;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IEditorDescriptor;
import org.eclipse.ui.ISharedImages;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.wizards.datatransfer.ZipFileStructureProvider;

/**
 * @author miya
 *
 */
public class ZipContentProvider extends LabelProvider
implements ITreeContentProvider, IDoubleClickListener 
{
//, IResourceChangeListener, IResourceDeltaVisitor{

	//Ȃ񂩉ȂĂBBB
	//private IFile sourceFile;
	private String zipFilePath;
	private ZipFile zipFile;
	private ZipFileStructureProvider zp;


//content provider methods
	public Object[] getChildren(Object parent) {
		List child = zp.getChildren(parent);
		if(child == null){
			return new Object[0];
		}
		return child.toArray();
	}

	public Object getParent(Object element) {
		return null;
	}

	public boolean hasChildren(Object element) {
		return getChildren(element).length > 0;
	}

	public Object[] getElements(Object input) {

		if(input instanceof IFile){
			ZipFile zipFile = createZipFile((IFile)input);
			zp = new ZipFileStructureProvider(zipFile);
			return getChildren(zp.getRoot());
		}

		return new Object[0];
	}

	public void dispose() {
		releaseFile();
	}

	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
	}


//label provider methods
	public String getText(Object element) {
		return zp.getLabel(element);
	}

	public Image getImage(Object element) {
		if(zp.isFolder(element)){
			return PlatformUI.getWorkbench().getSharedImages().getImage(ISharedImages.IMG_OBJ_FOLDER);
		}else{
			return PlatformUI.getWorkbench().getSharedImages().getImage(ISharedImages.IMG_OBJ_FILE);			
		}
	}


//double click listener
//TODO EditorI|bvAbv
	public void doubleClick(DoubleClickEvent event) {
		ZipEntry entry = (ZipEntry)((StructuredSelection)event.getSelection()).getFirstElement();
		String fileName = zp.getLabel(entry);
		
		String editorId = null;
		IEditorDescriptor desc = PlatformUI.getWorkbench().getEditorRegistry().getDefaultEditor(fileName);
		if(desc != null){
			editorId = desc.getId();
		}
		if(editorId == null){
			editorId = PlatformUI.getWorkbench().getEditorRegistry().getDefaultEditor().getId();			
		}
		System.out.println(editorId);

		JarEntryFile jarEntryFile = new JarEntryFile(entry.getName(), zipFilePath);
		JarEntryEditorInput editorInput = new JarEntryEditorInput(jarEntryFile);

		try {
			ZipViewPlugin.getPage().openEditor(editorInput, editorId);
		} catch (PartInitException e) {
			e.printStackTrace();
		}
	}
	
	
//sorter	
	public class ZipEntrySorter extends ViewerSorter{
		public int category(Object element) {
			if(zp.isFolder(element)){
				return 0;
			}else {
				return 1;
			}
		}
	}

	private ZipEntrySorter sorter = new ZipEntrySorter();
	
	public ViewerSorter getSorter(){
		return sorter;
	}



//resource change listener
//	public void resourceChanged(IResourceChangeEvent event) {
//		try {
//			event.getDelta().accept(this);
//		} catch (CoreException e) {
//			e.printStackTrace();
//		}
//	}
//	
//
//	public boolean visit(IResourceDelta delta) throws CoreException {
//		System.out.println(delta.getResource());
//		if(delta.getResource().equals(sourceFile)){
//			releaseFile();
//		}
//		return true;
//	}
	
	
	private ZipFile createZipFile(IFile file){
		releaseFile();
		//sourceFile = file;
		IPath path = file.getLocation();
		zipFilePath = path.toFile().getAbsolutePath();
		File jFile = new File(zipFilePath);
		try {
			zipFile = new ZipFile(jFile);
			//ResourcesPlugin.getWorkspace().addResourceChangeListener(this);
			return zipFile;
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}

	private void releaseFile(){
		//ResourcesPlugin.getWorkspace().removeResourceChangeListener(this);
		if(zipFile != null){
			try {
				zipFile.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
}
